#!/bin/bash

usage()
{
cat << EOF
Utilisation :
-------------
./veritas_fs.sh [volume] [service_group] [veritas_dg] [diskgroup] [host] [device] [fs] [no_fs] [appli]

Exemple :
---------
./veritas_fs.sh dexA_cft dexA_SG dg_dexA dexA_DG parcl1111013 /dev/vx/dsk/dg_dexA/cft_dexA /apps/cft_dexa 15 dexA_appli
EOF
}

[[ $# -ne 9 ]] && clear && echo "Nb de parametres incorrect !!" && usage && exit

# Variables

CONF=/etc/VRTSvcs/conf/config/main.cf

VOLNAME=$1
SG=$2
DG=$3
VDG=$4
HOST=$5
DEV=$6
FS=$7
NB=$8
APPLI=$9

#############################
#### Check des parametres ###
#############################

if grep $VOLNAME $CONF >/dev/null;then
echo "$VOLNAME deja defini !"
exit
fi

if ! grep $SG $CONF >/dev/null;then
echo "$SG non existant !"
exit
fi

if ! vxdisk -oalldgs list|grep $DG >/dev/null;then
echo "$DG non existant !"
exit
fi

if nslookup $HOST|grep "can't" > /dev/null;then
echo "$HOST non existant !"
exit
fi

if [ ! -b $DEV ];then
echo "$DEV non existant !"
exit
fi

if grep $DEV $CONF;then
echo "$DEV deja utilise dans la conf, cf. $CONF"
exit
fi


if [ ! -d $FS ];then
echo "Point de montage $FS non existant !"
exit
fi

# on genere les commandes a lancer

echo "haconf -makerw
hares -add ${VOLNAME}_Vol${NB} Volume $SG
hares -modify ${VOLNAME}_Vol${NB} Critical 1
hares -modify ${VOLNAME}_Vol${NB} Volume ${VOLNAME}
hares -modify ${VOLNAME}_Vol${NB} DiskGroup $DG
hares -modify ${VOLNAME}_Vol${NB} Enabled 1
hares -online ${VOLNAME}_Vol${NB} -sys $HOST
hares -add ${VOLNAME}_Mount${NB} Mount $SG
hares -modify  ${VOLNAME}_Mount${NB} Critical 1
hares -modify ${VOLNAME}_Mount${NB} MountPoint $FS
hares -modify  ${VOLNAME}_Mount${NB} BlockDevice $DEV
hares -modify ${VOLNAME}_Mount${NB} FSType vxfs
hares -modify ${VOLNAME}_Mount${NB} FsckOpt %-y
hares -modify  ${VOLNAME}_Mount${NB} Enabled 1
hares -online ${VOLNAME}_Mount${NB} -sys $HOST
hares -link ${VOLNAME}_Mount${NB} ${VOLNAME}_Vol${NB}
hares -link ${VOLNAME}_Vol${NB} $VDG
hares -link $APPLI ${VOLNAME}_Mount${NB}
hares -online ${VOLNAME}_Vol${NB} -sys $HOST
hares -online ${VOLNAME}_Mount${NB} -sys $HOST
haconf -dump -makero"
